Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 313)
+++ lemon/concepts/graph_components.h	(revision 617)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2008
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -21,7 +21,6 @@
 ///\brief The concept of graph components.
 
-
-#ifndef LEMON_CONCEPT_GRAPH_COMPONENTS_H
-#define LEMON_CONCEPT_GRAPH_COMPONENTS_H
+#ifndef LEMON_CONCEPTS_GRAPH_COMPONENTS_H
+#define LEMON_CONCEPTS_GRAPH_COMPONENTS_H
 
 #include <lemon/core.h>
@@ -33,17 +32,16 @@
   namespace concepts {
 
-    /// \brief Skeleton class for graph Node and Arc types
-    ///
-    /// This class describes the interface of Node and Arc (and Edge
-    /// in undirected graphs) subtypes of graph types.
+    /// \brief Concept class for \c Node, \c Arc and \c Edge types.
+    ///
+    /// This class describes the concept of \c Node, \c Arc and \c Edge
+    /// subtypes of digraph and graph types.
     ///
     /// \note This class is a template class so that we can use it to
-    /// create graph skeleton classes. The reason for this is than Node
-    /// and Arc types should \em not derive from the same base class.
-    /// For Node you should instantiate it with character 'n' and for Arc
-    /// with 'a'.
-
+    /// create graph skeleton classes. The reason for this is that \c Node
+    /// and \c Arc (or \c Edge) types should \e not derive from the same 
+    /// base class. For \c Node you should instantiate it with character
+    /// \c 'n', for \c Arc with \c 'a' and for \c Edge with \c 'e'.
 #ifndef DOXYGEN
-    template <char _selector = '0'>
+    template <char sel = '0'>
 #endif
     class GraphItem {
@@ -51,43 +49,47 @@
       /// \brief Default constructor.
       ///
+      /// Default constructor.
       /// \warning The default constructor is not required to set
       /// the item to some well-defined value. So you should consider it
       /// as uninitialized.
       GraphItem() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
       GraphItem(const GraphItem &) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the item to be invalid.
       /// \sa Invalid for more details.
       GraphItem(Invalid) {}
-      /// \brief Assign operator for nodes.
-      ///
-      /// The nodes are assignable.
-      ///
-      GraphItem& operator=(GraphItem const&) { return *this; }
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the item.
+      GraphItem& operator=(const GraphItem&) { return *this; }
+
       /// \brief Equality operator.
       ///
-      /// Two iterators are equal if and only if they represents the
-      /// same node in the graph or both are invalid.
-      bool operator==(GraphItem) const { return false; }
+      /// Equality operator.
+      bool operator==(const GraphItem&) const { return false; }
+
       /// \brief Inequality operator.
       ///
-      /// \sa operator==(const Node& n)
-      ///
-      bool operator!=(GraphItem) const { return false; }
-
-      /// \brief Artificial ordering operator.
-      ///
-      /// To allow the use of graph descriptors as key type in std::map or
-      /// similar associative container we require this.
+      /// Inequality operator.
+      bool operator!=(const GraphItem&) const { return false; }
+
+      /// \brief Ordering operator.
+      ///
+      /// This operator defines an ordering of the items.
+      /// It makes possible to use graph item types as key types in 
+      /// associative containers (e.g. \c std::map).
       ///
       /// \note This operator only have to define some strict ordering of
       /// the items; this order has nothing to do with the iteration
       /// ordering of the items.
-      bool operator<(GraphItem) const { return false; }
+      bool operator<(const GraphItem&) const { return false; }
 
       template<typename _GraphItem>
@@ -101,5 +103,4 @@
 
           bool b;
-          //          b = (ia == ib) && (ia != ib) && (ia < ib);
           b = (ia == ib) && (ia != ib);
           b = (ia == INVALID) && (ib != INVALID);
@@ -112,11 +113,10 @@
     };
 
-    /// \brief An empty base directed graph class.
-    ///
-    /// This class provides the minimal set of features needed for a
-    /// directed graph structure. All digraph concepts have to be
-    /// conform to this base directed graph. It just provides types
-    /// for nodes and arcs and functions to get the source and the
-    /// target of the arcs.
+    /// \brief Base skeleton class for directed graphs.
+    ///
+    /// This class describes the base interface of directed graph types.
+    /// All digraph %concepts have to conform to this class.
+    /// It just provides types for nodes and arcs and functions 
+    /// to get the source and the target nodes of arcs.
     class BaseDigraphComponent {
     public:
@@ -126,29 +126,25 @@
       /// \brief Node class of the digraph.
       ///
-      /// This class represents the Nodes of the digraph.
-      ///
+      /// This class represents the nodes of the digraph.
       typedef GraphItem<'n'> Node;
 
       /// \brief Arc class of the digraph.
       ///
-      /// This class represents the Arcs of the digraph.
-      ///
-      typedef GraphItem<'e'> Arc;
-
-      /// \brief Gives back the target node of an arc.
-      ///
-      /// Gives back the target node of an arc.
-      ///
-      Node target(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back the source node of an arc.
-      ///
-      /// Gives back the source node of an arc.
-      ///
-      Node source(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back the opposite node on the given arc.
-      ///
-      /// Gives back the opposite node on the given arc.
+      /// This class represents the arcs of the digraph.
+      typedef GraphItem<'a'> Arc;
+
+      /// \brief Return the source node of an arc.
+      ///
+      /// This function returns the source node of an arc.
+      Node source(const Arc&) const { return INVALID; }
+
+      /// \brief Return the target node of an arc.
+      ///
+      /// This function returns the target node of an arc.
+      Node target(const Arc&) const { return INVALID; }
+
+      /// \brief Return the opposite node on the given arc.
+      ///
+      /// This function returns the opposite node on the given arc.
       Node oppositeNode(const Node&, const Arc&) const {
         return INVALID;
@@ -176,50 +172,58 @@
     };
 
-    /// \brief An empty base undirected graph class.
-    ///
-    /// This class provides the minimal set of features needed for an
-    /// undirected graph structure. All undirected graph concepts have
-    /// to be conform to this base graph. It just provides types for
-    /// nodes, arcs and edges and functions to get the
-    /// source and the target of the arcs and edges,
-    /// conversion from arcs to edges and function to get
-    /// both direction of the edges.
+    /// \brief Base skeleton class for undirected graphs.
+    ///
+    /// This class describes the base interface of undirected graph types.
+    /// All graph %concepts have to conform to this class.
+    /// It extends the interface of \ref BaseDigraphComponent with an
+    /// \c Edge type and functions to get the end nodes of edges,
+    /// to convert from arcs to edges and to get both direction of edges.
     class BaseGraphComponent : public BaseDigraphComponent {
     public:
+
+      typedef BaseGraphComponent Graph;
+
       typedef BaseDigraphComponent::Node Node;
       typedef BaseDigraphComponent::Arc Arc;
-      /// \brief Undirected arc class of the graph.
-      ///
-      /// This class represents the edges of the graph.
-      /// The undirected graphs can be used as a directed graph which
-      /// for each arc contains the opposite arc too so the graph is
-      /// bidirected. The edge represents two opposite
-      /// directed arcs.
-      class Edge : public GraphItem<'u'> {
+
+      /// \brief Undirected edge class of the graph.
+      ///
+      /// This class represents the undirected edges of the graph.
+      /// Undirected graphs can be used as directed graphs, each edge is
+      /// represented by two opposite directed arcs.
+      class Edge : public GraphItem<'e'> {
+        typedef GraphItem<'e'> Parent;
+
       public:
-        typedef GraphItem<'u'> Parent;
         /// \brief Default constructor.
         ///
+        /// Default constructor.
         /// \warning The default constructor is not required to set
         /// the item to some well-defined value. So you should consider it
         /// as uninitialized.
         Edge() {}
+
         /// \brief Copy constructor.
         ///
         /// Copy constructor.
-        ///
         Edge(const Edge &) : Parent() {}
-        /// \brief Invalid constructor \& conversion.
-        ///
-        /// This constructor initializes the item to be invalid.
+
+        /// \brief Constructor for conversion from \c INVALID.
+        ///
+        /// Constructor for conversion from \c INVALID.
+        /// It initializes the item to be invalid.
         /// \sa Invalid for more details.
         Edge(Invalid) {}
-        /// \brief Converter from arc to edge.
-        ///
+
+        /// \brief Constructor for conversion from an arc.
+        ///
+        /// Constructor for conversion from an arc.
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
         Edge(const Arc&) {}
-        /// \brief Assign arc to edge.
-        ///
+
+        /// \brief Assign an arc to an edge.
+        ///
+        /// This function assigns an arc to an edge.
         /// Besides the core graph item functionality each arc should
         /// be convertible to the represented edge.
@@ -227,5 +231,27 @@
       };
 
-      /// \brief Returns the direction of the arc.
+      /// \brief Return one end node of an edge.
+      ///
+      /// This function returns one end node of an edge.
+      Node u(const Edge&) const { return INVALID; }
+
+      /// \brief Return the other end node of an edge.
+      ///
+      /// This function returns the other end node of an edge.
+      Node v(const Edge&) const { return INVALID; }
+
+      /// \brief Return a directed arc related to an edge.
+      ///
+      /// This function returns a directed arc from its direction and the
+      /// represented edge.
+      Arc direct(const Edge&, bool) const { return INVALID; }
+
+      /// \brief Return a directed arc related to an edge.
+      ///
+      /// This function returns a directed arc from its source node and the
+      /// represented edge.
+      Arc direct(const Edge&, const Node&) const { return INVALID; }
+
+      /// \brief Return the direction of the arc.
       ///
       /// Returns the direction of the arc. Each arc represents an
@@ -234,31 +260,9 @@
       bool direction(const Arc&) const { return true; }
 
-      /// \brief Returns the directed arc.
-      ///
-      /// Returns the directed arc from its direction and the
-      /// represented edge.
-      Arc direct(const Edge&, bool) const { return INVALID;}
-
-      /// \brief Returns the directed arc.
-      ///
-      /// Returns the directed arc from its source and the
-      /// represented edge.
-      Arc direct(const Edge&, const Node&) const { return INVALID;}
-
-      /// \brief Returns the opposite arc.
-      ///
-      /// Returns the opposite arc. It is the arc representing the
-      /// same edge and has opposite direction.
-      Arc oppositeArc(const Arc&) const { return INVALID;}
-
-      /// \brief Gives back one ending of an edge.
-      ///
-      /// Gives back one ending of an edge.
-      Node u(const Edge&) const { return INVALID;}
-
-      /// \brief Gives back the other ending of an edge.
-      ///
-      /// Gives back the other ending of an edge.
-      Node v(const Edge&) const { return INVALID;}
+      /// \brief Return the opposite arc.
+      ///
+      /// This function returns the opposite arc, i.e. the arc representing
+      /// the same edge and has opposite direction.
+      Arc oppositeArc(const Arc&) const { return INVALID; }
 
       template <typename _Graph>
@@ -270,5 +274,5 @@
         void constraints() {
           checkConcept<BaseDigraphComponent, _Graph>();
-          checkConcept<GraphItem<'u'>, Edge>();
+          checkConcept<GraphItem<'e'>, Edge>();
           {
             Node n;
@@ -278,4 +282,5 @@
             n = graph.v(ue);
             e = graph.direct(ue, true);
+            e = graph.direct(ue, false);
             e = graph.direct(ue, n);
             e = graph.oppositeArc(e);
@@ -291,57 +296,55 @@
     };
 
-    /// \brief An empty idable base digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// core id functions for the digraph structure.
-    /// The most of the base digraphs should be conform to this concept.
-    /// The id's are unique and immutable.
-    template <typename _Base = BaseDigraphComponent>
-    class IDableDigraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
+    /// \brief Skeleton class for \e idable directed graphs.
+    ///
+    /// This class describes the interface of \e idable directed graphs.
+    /// It extends \ref BaseDigraphComponent with the core ID functions.
+    /// The ids of the items must be unique and immutable.
+    /// This concept is part of the Digraph concept.
+    template <typename BAS = BaseDigraphComponent>
+    class IDableDigraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
 
-      /// \brief Gives back an unique integer id for the Node.
-      ///
-      /// Gives back an unique integer id for the Node.
-      ///
-      int id(const Node&) const { return -1;}
-
-      /// \brief Gives back the node by the unique id.
-      ///
-      /// Gives back the node by the unique id.
-      /// If the digraph does not contain node with the given id
-      /// then the result of the function is undetermined.
-      Node nodeFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an unique integer id for the Arc.
-      ///
-      /// Gives back an unique integer id for the Arc.
-      ///
-      int id(const Arc&) const { return -1;}
-
-      /// \brief Gives back the arc by the unique id.
-      ///
-      /// Gives back the arc by the unique id.
-      /// If the digraph does not contain arc with the given id
-      /// then the result of the function is undetermined.
-      Arc arcFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Node id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Node
-      /// id.
-      int maxNodeId() const { return -1;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Arc id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Arc
-      /// id.
-      int maxArcId() const { return -1;}
+      /// \brief Return a unique integer id for the given node.
+      ///
+      /// This function returns a unique integer id for the given node.
+      int id(const Node&) const { return -1; }
+
+      /// \brief Return the node by its unique id.
+      ///
+      /// This function returns the node by its unique id.
+      /// If the digraph does not contain a node with the given id,
+      /// then the result of the function is undefined.
+      Node nodeFromId(int) const { return INVALID; }
+
+      /// \brief Return a unique integer id for the given arc.
+      ///
+      /// This function returns a unique integer id for the given arc.
+      int id(const Arc&) const { return -1; }
+
+      /// \brief Return the arc by its unique id.
+      ///
+      /// This function returns the arc by its unique id.
+      /// If the digraph does not contain an arc with the given id,
+      /// then the result of the function is undefined.
+      Arc arcFromId(int) const { return INVALID; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// node id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum node id.
+      int maxNodeId() const { return -1; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// arc id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum arc id.
+      int maxArcId() const { return -1; }
 
       template <typename _Digraph>
@@ -369,38 +372,38 @@
     };
 
-    /// \brief An empty idable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core id functions for the undirected graph structure.  The
-    /// most of the base undirected graphs should be conform to this
-    /// concept.  The id's are unique and immutable.
-    template <typename _Base = BaseGraphComponent>
-    class IDableGraphComponent : public IDableDigraphComponent<_Base> {
-    public:
-
-      typedef _Base Base;
+    /// \brief Skeleton class for \e idable undirected graphs.
+    ///
+    /// This class describes the interface of \e idable undirected
+    /// graphs. It extends \ref IDableDigraphComponent with the core ID
+    /// functions of undirected graphs.
+    /// The ids of the items must be unique and immutable.
+    /// This concept is part of the Graph concept.
+    template <typename BAS = BaseGraphComponent>
+    class IDableGraphComponent : public IDableDigraphComponent<BAS> {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Edge Edge;
 
-      using IDableDigraphComponent<_Base>::id;
-
-      /// \brief Gives back an unique integer id for the Edge.
-      ///
-      /// Gives back an unique integer id for the Edge.
-      ///
-      int id(const Edge&) const { return -1;}
-
-      /// \brief Gives back the edge by the unique id.
-      ///
-      /// Gives back the edge by the unique id.  If the
-      /// graph does not contain arc with the given id then the
-      /// result of the function is undetermined.
-      Edge edgeFromId(int) const { return INVALID;}
-
-      /// \brief Gives back an integer greater or equal to the maximum
-      /// Edge id.
-      ///
-      /// Gives back an integer greater or equal to the maximum Edge
-      /// id.
-      int maxEdgeId() const { return -1;}
+      using IDableDigraphComponent<Base>::id;
+
+      /// \brief Return a unique integer id for the given edge.
+      ///
+      /// This function returns a unique integer id for the given edge.
+      int id(const Edge&) const { return -1; }
+
+      /// \brief Return the edge by its unique id.
+      ///
+      /// This function returns the edge by its unique id.
+      /// If the graph does not contain an edge with the given id,
+      /// then the result of the function is undefined.
+      Edge edgeFromId(int) const { return INVALID; }
+
+      /// \brief Return an integer greater or equal to the maximum
+      /// edge id.
+      ///
+      /// This function returns an integer greater or equal to the
+      /// maximum edge id.
+      int maxEdgeId() const { return -1; }
 
       template <typename _Graph>
@@ -408,5 +411,4 @@
 
         void constraints() {
-          checkConcept<Base, _Graph >();
           checkConcept<IDableDigraphComponent<Base>, _Graph >();
           typename _Graph::Edge edge;
@@ -422,50 +424,59 @@
     };
 
-    /// \brief Skeleton class for graph NodeIt and ArcIt
-    ///
-    /// Skeleton class for graph NodeIt and ArcIt.
-    ///
-    template <typename _Graph, typename _Item>
-    class GraphItemIt : public _Item {
+    /// \brief Concept class for \c NodeIt, \c ArcIt and \c EdgeIt types.
+    ///
+    /// This class describes the concept of \c NodeIt, \c ArcIt and 
+    /// \c EdgeIt subtypes of digraph and graph types.
+    template <typename GR, typename Item>
+    class GraphItemIt : public Item {
     public:
       /// \brief Default constructor.
       ///
-      /// @warning The default constructor sets the iterator
-      /// to an undefined value.
+      /// Default constructor.
+      /// \warning The default constructor is not required to set
+      /// the iterator to some well-defined value. So you should consider it
+      /// as uninitialized.
       GraphItemIt() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
-      GraphItemIt(const GraphItemIt& ) {}
-      /// \brief Sets the iterator to the first item.
-      ///
-      /// Sets the iterator to the first item of \c the graph.
-      ///
-      explicit GraphItemIt(const _Graph&) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+      GraphItemIt(const GraphItemIt& it) : Item(it) {}
+
+      /// \brief Constructor that sets the iterator to the first item.
+      ///
+      /// Constructor that sets the iterator to the first item.
+      explicit GraphItemIt(const GR&) {}
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the iterator to be invalid.
       /// \sa Invalid for more details.
       GraphItemIt(Invalid) {}
-      /// \brief Assign operator for items.
-      ///
-      /// The items are assignable.
-      ///
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the iterator.
       GraphItemIt& operator=(const GraphItemIt&) { return *this; }
-      /// \brief Next item.
-      ///
-      /// Assign the iterator to the next item.
-      ///
+
+      /// \brief Increment the iterator.
+      ///
+      /// This operator increments the iterator, i.e. assigns it to the
+      /// next item.
       GraphItemIt& operator++() { return *this; }
+ 
       /// \brief Equality operator
       ///
+      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
       bool operator==(const GraphItemIt&) const { return true;}
+
       /// \brief Inequality operator
       ///
-      /// \sa operator==(Node n)
-      ///
+      /// Inequality operator.
+      /// Two iterators are equal if and only if they point to the
+      /// same object or both are invalid.
       bool operator!=(const GraphItemIt&) const { return true;}
 
@@ -473,6 +484,9 @@
       struct Constraints {
         void constraints() {
+          checkConcept<GraphItem<>, _GraphItemIt>();
           _GraphItemIt it1(g);
           _GraphItemIt it2;
+          _GraphItemIt it3 = it1;
+          _GraphItemIt it4 = INVALID;
 
           it2 = ++it1;
@@ -480,58 +494,68 @@
           ++(++it1);
 
-          _Item bi = it1;
+          Item bi = it1;
           bi = it2;
         }
-        _Graph& g;
-      };
-    };
-
-    /// \brief Skeleton class for graph InArcIt and OutArcIt
-    ///
-    /// \note Because InArcIt and OutArcIt may not inherit from the same
-    /// base class, the _selector is a additional template parameter. For
-    /// InArcIt you should instantiate it with character 'i' and for
-    /// OutArcIt with 'o'.
-    template <typename _Graph,
-              typename _Item = typename _Graph::Arc,
-              typename _Base = typename _Graph::Node,
-              char _selector = '0'>
-    class GraphIncIt : public _Item {
+        const GR& g;
+      };
+    };
+
+    /// \brief Concept class for \c InArcIt, \c OutArcIt and 
+    /// \c IncEdgeIt types.
+    ///
+    /// This class describes the concept of \c InArcIt, \c OutArcIt 
+    /// and \c IncEdgeIt subtypes of digraph and graph types.
+    ///
+    /// \note Since these iterator classes do not inherit from the same
+    /// base class, there is an additional template parameter (selector)
+    /// \c sel. For \c InArcIt you should instantiate it with character 
+    /// \c 'i', for \c OutArcIt with \c 'o' and for \c IncEdgeIt with \c 'e'.
+    template <typename GR,
+              typename Item = typename GR::Arc,
+              typename Base = typename GR::Node,
+              char sel = '0'>
+    class GraphIncIt : public Item {
     public:
       /// \brief Default constructor.
       ///
-      /// @warning The default constructor sets the iterator
-      /// to an undefined value.
+      /// Default constructor.
+      /// \warning The default constructor is not required to set
+      /// the iterator to some well-defined value. So you should consider it
+      /// as uninitialized.
       GraphIncIt() {}
+
       /// \brief Copy constructor.
       ///
       /// Copy constructor.
-      ///
-      GraphIncIt(GraphIncIt const& gi) : _Item(gi) {}
-      /// \brief Sets the iterator to the first arc incoming into or outgoing
-      /// from the node.
-      ///
-      /// Sets the iterator to the first arc incoming into or outgoing
-      /// from the node.
-      ///
-      explicit GraphIncIt(const _Graph&, const _Base&) {}
-      /// \brief Invalid constructor \& conversion.
-      ///
-      /// This constructor initializes the item to be invalid.
+      GraphIncIt(const GraphIncIt& it) : Item(it) {}
+
+      /// \brief Constructor that sets the iterator to the first 
+      /// incoming or outgoing arc.
+      ///
+      /// Constructor that sets the iterator to the first arc 
+      /// incoming to or outgoing from the given node.
+      explicit GraphIncIt(const GR&, const Base&) {}
+
+      /// \brief Constructor for conversion from \c INVALID.
+      ///
+      /// Constructor for conversion from \c INVALID.
+      /// It initializes the iterator to be invalid.
       /// \sa Invalid for more details.
       GraphIncIt(Invalid) {}
-      /// \brief Assign operator for iterators.
-      ///
-      /// The iterators are assignable.
-      ///
-      GraphIncIt& operator=(GraphIncIt const&) { return *this; }
-      /// \brief Next item.
-      ///
-      /// Assign the iterator to the next item.
-      ///
+
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator for the iterator.
+      GraphIncIt& operator=(const GraphIncIt&) { return *this; }
+
+      /// \brief Increment the iterator.
+      ///
+      /// This operator increments the iterator, i.e. assigns it to the
+      /// next arc incoming to or outgoing from the given node.
       GraphIncIt& operator++() { return *this; }
 
       /// \brief Equality operator
       ///
+      /// Equality operator.
       /// Two iterators are equal if and only if they point to the
       /// same object or both are invalid.
@@ -540,6 +564,7 @@
       /// \brief Inequality operator
       ///
-      /// \sa operator==(Node n)
-      ///
+      /// Inequality operator.
+      /// Two iterators are equal if and only if they point to the
+      /// same object or both are invalid.
       bool operator!=(const GraphIncIt&) const { return true;}
 
@@ -547,35 +572,33 @@
       struct Constraints {
         void constraints() {
-          checkConcept<GraphItem<_selector>, _GraphIncIt>();
+          checkConcept<GraphItem<sel>, _GraphIncIt>();
           _GraphIncIt it1(graph, node);
           _GraphIncIt it2;
+          _GraphIncIt it3 = it1;
+          _GraphIncIt it4 = INVALID;
 
           it2 = ++it1;
           ++it2 = it1;
           ++(++it1);
-          _Item e = it1;
+          Item e = it1;
           e = it2;
-
-        }
-
-        _Item arc;
-        _Base node;
-        _Graph graph;
-        _GraphIncIt it;
-      };
-    };
-
-
-    /// \brief An empty iterable digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// iterator based iterable interface for the digraph structure.
+        }
+        const Base& node;
+        const GR& graph;
+      };
+    };
+
+    /// \brief Skeleton class for iterable directed graphs.
+    ///
+    /// This class describes the interface of iterable directed
+    /// graphs. It extends \ref BaseDigraphComponent with the core
+    /// iterable interface.
     /// This concept is part of the Digraph concept.
-    template <typename _Base = BaseDigraphComponent>
-    class IterableDigraphComponent : public _Base {
-
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseDigraphComponent>
+    class IterableDigraphComponent : public BAS {
+
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -583,68 +606,59 @@
       typedef IterableDigraphComponent Digraph;
 
-      /// \name Base iteration
-      ///
-      /// This interface provides functions for iteration on digraph items
+      /// \name Base Iteration
+      ///
+      /// This interface provides functions for iteration on digraph items.
       ///
       /// @{
 
-      /// \brief Gives back the first node in the iterating order.
-      ///
-      /// Gives back the first node in the iterating order.
-      ///
+      /// \brief Return the first node.
+      ///
+      /// This function gives back the first node in the iteration order.
       void first(Node&) const {}
 
-      /// \brief Gives back the next node in the iterating order.
-      ///
-      /// Gives back the next node in the iterating order.
-      ///
+      /// \brief Return the next node.
+      ///
+      /// This function gives back the next node in the iteration order.
       void next(Node&) const {}
 
-      /// \brief Gives back the first arc in the iterating order.
-      ///
-      /// Gives back the first arc in the iterating order.
-      ///
+      /// \brief Return the first arc.
+      ///
+      /// This function gives back the first arc in the iteration order.
       void first(Arc&) const {}
 
-      /// \brief Gives back the next arc in the iterating order.
-      ///
-      /// Gives back the next arc in the iterating order.
-      ///
+      /// \brief Return the next arc.
+      ///
+      /// This function gives back the next arc in the iteration order.
       void next(Arc&) const {}
 
-
-      /// \brief Gives back the first of the arcs point to the given
-      /// node.
-      ///
-      /// Gives back the first of the arcs point to the given node.
-      ///
+      /// \brief Return the first arc incomming to the given node.
+      ///
+      /// This function gives back the first arc incomming to the
+      /// given node.
       void firstIn(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs points to the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs points to the given node.
-      ///
+      /// \brief Return the next arc incomming to the given node.
+      ///
+      /// This function gives back the next arc incomming to the
+      /// given node.
       void nextIn(Arc&) const {}
 
-      /// \brief Gives back the first of the arcs start from the
+      /// \brief Return the first arc outgoing form the given node.
+      ///
+      /// This function gives back the first arc outgoing form the
       /// given node.
-      ///
-      /// Gives back the first of the arcs start from the given node.
-      ///
       void firstOut(Arc&, const Node&) const {}
 
-      /// \brief Gives back the next of the arcs start from the given
-      /// node.
-      ///
-      /// Gives back the next of the arcs start from the given node.
-      ///
+      /// \brief Return the next arc outgoing form the given node.
+      ///
+      /// This function gives back the next arc outgoing form the
+      /// given node.
       void nextOut(Arc&) const {}
 
       /// @}
 
-      /// \name Class based iteration
-      ///
-      /// This interface provides functions for iteration on digraph items
+      /// \name Class Based Iteration
+      ///
+      /// This interface provides iterator classes for digraph items.
       ///
       /// @{
@@ -656,7 +670,7 @@
       typedef GraphItemIt<Digraph, Node> NodeIt;
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each arc.
+      ///
+      /// This iterator goes through each arc.
       ///
       typedef GraphItemIt<Digraph, Arc> ArcIt;
@@ -664,5 +678,5 @@
       /// \brief This iterator goes trough the incoming arcs of a node.
       ///
-      /// This iterator goes trough the \e inccoming arcs of a certain node
+      /// This iterator goes trough the \e incoming arcs of a certain node
       /// of a digraph.
       typedef GraphIncIt<Digraph, Arc, Node, 'i'> InArcIt;
@@ -676,24 +690,24 @@
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node baseNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node runningNode(const InArcIt&) const { return INVALID; }
 
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
-      /// It is always the source of the pointed arc.
+      /// This function gives back the base node of the iterator.
+      /// It is always the source node of the pointed arc.
       Node baseNode(const OutArcIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
-      /// It is always the target of the pointed arc.
+      /// This function gives back the running node of the iterator.
+      /// It is always the target node of the pointed arc.
       Node runningNode(const OutArcIt&) const { return INVALID; }
 
@@ -737,10 +751,10 @@
 
             typename _Digraph::Node n;
-            typename _Digraph::InArcIt ieit(INVALID);
-            typename _Digraph::OutArcIt oeit(INVALID);
-            n = digraph.baseNode(ieit);
-            n = digraph.runningNode(ieit);
-            n = digraph.baseNode(oeit);
-            n = digraph.runningNode(oeit);
+            const typename _Digraph::InArcIt iait(INVALID);
+            const typename _Digraph::OutArcIt oait(INVALID);
+            n = digraph.baseNode(iait);
+            n = digraph.runningNode(iait);
+            n = digraph.baseNode(oait);
+            n = digraph.runningNode(oait);
             ignore_unused_variable_warning(n);
           }
@@ -748,18 +762,18 @@
 
         const _Digraph& digraph;
-
-      };
-    };
-
-    /// \brief An empty iterable undirected graph class.
-    ///
-    /// This class provides beside the core graph features iterator
-    /// based iterable interface for the undirected graph structure.
+      };
+    };
+
+    /// \brief Skeleton class for iterable undirected graphs.
+    ///
+    /// This class describes the interface of iterable undirected
+    /// graphs. It extends \ref IterableDigraphComponent with the core
+    /// iterable interface of undirected graphs.
     /// This concept is part of the Graph concept.
-    template <typename _Base = BaseGraphComponent>
-    class IterableGraphComponent : public IterableDigraphComponent<_Base> {
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseGraphComponent>
+    class IterableGraphComponent : public IterableDigraphComponent<BAS> {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -769,34 +783,29 @@
       typedef IterableGraphComponent Graph;
 
-      /// \name Base iteration
-      ///
-      /// This interface provides functions for iteration on graph items
+      /// \name Base Iteration
+      ///
+      /// This interface provides functions for iteration on edges.
+      ///
       /// @{
 
-      using IterableDigraphComponent<_Base>::first;
-      using IterableDigraphComponent<_Base>::next;
-
-      /// \brief Gives back the first edge in the iterating
-      /// order.
-      ///
-      /// Gives back the first edge in the iterating order.
-      ///
+      using IterableDigraphComponent<Base>::first;
+      using IterableDigraphComponent<Base>::next;
+
+      /// \brief Return the first edge.
+      ///
+      /// This function gives back the first edge in the iteration order.
       void first(Edge&) const {}
 
-      /// \brief Gives back the next edge in the iterating
-      /// order.
-      ///
-      /// Gives back the next edge in the iterating order.
-      ///
+      /// \brief Return the next edge.
+      ///
+      /// This function gives back the next edge in the iteration order.
       void next(Edge&) const {}
 
-
-      /// \brief Gives back the first of the edges from the
+      /// \brief Return the first edge incident to the given node.
+      ///
+      /// This function gives back the first edge incident to the given 
+      /// node. The bool parameter gives back the direction for which the
+      /// source node of the directed arc representing the edge is the 
       /// given node.
-      ///
-      /// Gives back the first of the edges from the given
-      /// node. The bool parameter gives back that direction which
-      /// gives a good direction of the edge so the source of the
-      /// directed arc is the given node.
       void firstInc(Edge&, bool&, const Node&) const {}
 
@@ -804,38 +813,39 @@
       /// given node.
       ///
-      /// Gives back the next of the edges from the given
-      /// node. The bool parameter should be used as the \c firstInc()
-      /// use it.
+      /// This function gives back the next edge incident to the given 
+      /// node. The bool parameter should be used as \c firstInc() use it.
       void nextInc(Edge&, bool&) const {}
 
-      using IterableDigraphComponent<_Base>::baseNode;
-      using IterableDigraphComponent<_Base>::runningNode;
+      using IterableDigraphComponent<Base>::baseNode;
+      using IterableDigraphComponent<Base>::runningNode;
 
       /// @}
 
-      /// \name Class based iteration
-      ///
-      /// This interface provides functions for iteration on graph items
+      /// \name Class Based Iteration
+      ///
+      /// This interface provides iterator classes for edges.
       ///
       /// @{
 
-      /// \brief This iterator goes through each node.
-      ///
-      /// This iterator goes through each node.
+      /// \brief This iterator goes through each edge.
+      ///
+      /// This iterator goes through each edge.
       typedef GraphItemIt<Graph, Edge> EdgeIt;
-      /// \brief This iterator goes trough the incident arcs of a
+
+      /// \brief This iterator goes trough the incident edges of a
       /// node.
       ///
-      /// This iterator goes trough the incident arcs of a certain
+      /// This iterator goes trough the incident edges of a certain
       /// node of a graph.
-      typedef GraphIncIt<Graph, Edge, Node, 'u'> IncEdgeIt;
+      typedef GraphIncIt<Graph, Edge, Node, 'e'> IncEdgeIt;
+
       /// \brief The base node of the iterator.
       ///
-      /// Gives back the base node of the iterator.
+      /// This function gives back the base node of the iterator.
       Node baseNode(const IncEdgeIt&) const { return INVALID; }
 
       /// \brief The running node of the iterator.
       ///
-      /// Gives back the running node of the iterator.
+      /// This function gives back the running node of the iterator.
       Node runningNode(const IncEdgeIt&) const { return INVALID; }
 
@@ -866,52 +876,52 @@
               typename _Graph::EdgeIt >();
             checkConcept<GraphIncIt<_Graph, typename _Graph::Edge,
-              typename _Graph::Node, 'u'>, typename _Graph::IncEdgeIt>();
+              typename _Graph::Node, 'e'>, typename _Graph::IncEdgeIt>();
 
             typename _Graph::Node n;
-            typename _Graph::IncEdgeIt ueit(INVALID);
-            n = graph.baseNode(ueit);
-            n = graph.runningNode(ueit);
+            const typename _Graph::IncEdgeIt ieit(INVALID);
+            n = graph.baseNode(ieit);
+            n = graph.runningNode(ieit);
           }
         }
 
         const _Graph& graph;
-
-      };
-    };
-
-    /// \brief An empty alteration notifier digraph class.
-    ///
-    /// This class provides beside the core digraph features alteration
-    /// notifier interface for the digraph structure.  This implements
+      };
+    };
+
+    /// \brief Skeleton class for alterable directed graphs.
+    ///
+    /// This class describes the interface of alterable directed
+    /// graphs. It extends \ref BaseDigraphComponent with the alteration
+    /// notifier interface. It implements
     /// an observer-notifier pattern for each digraph item. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the digraph all the observers will
+    /// alteration occured in the digraph all the observers will be
     /// notified about it.
-    template <typename _Base = BaseDigraphComponent>
-    class AlterableDigraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseDigraphComponent>
+    class AlterableDigraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
 
 
-      /// The node observer registry.
+      /// Node alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Node>
       NodeNotifier;
-      /// The arc observer registry.
+      /// Arc alteration notifier class.
       typedef AlterationNotifier<AlterableDigraphComponent, Arc>
       ArcNotifier;
 
-      /// \brief Gives back the node alteration notifier.
-      ///
-      /// Gives back the node alteration notifier.
+      /// \brief Return the node alteration notifier.
+      ///
+      /// This function gives back the node alteration notifier.
       NodeNotifier& notifier(Node) const {
-        return NodeNotifier();
+         return NodeNotifier();
       }
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the arc alteration notifier.
+      ///
+      /// This function gives back the arc alteration notifier.
       ArcNotifier& notifier(Arc) const {
         return ArcNotifier();
@@ -933,32 +943,31 @@
 
         const _Digraph& digraph;
-
-      };
-
-    };
-
-    /// \brief An empty alteration notifier undirected graph class.
-    ///
-    /// This class provides beside the core graph features alteration
-    /// notifier interface for the graph structure.  This implements
-    /// an observer-notifier pattern for each graph item. More
+      };
+    };
+
+    /// \brief Skeleton class for alterable undirected graphs.
+    ///
+    /// This class describes the interface of alterable undirected
+    /// graphs. It extends \ref AlterableDigraphComponent with the alteration
+    /// notifier interface of undirected graphs. It implements
+    /// an observer-notifier pattern for the edges. More
     /// obsevers can be registered into the notifier and whenever an
-    /// alteration occured in the graph all the observers will
+    /// alteration occured in the graph all the observers will be
     /// notified about it.
-    template <typename _Base = BaseGraphComponent>
-    class AlterableGraphComponent : public AlterableDigraphComponent<_Base> {
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseGraphComponent>
+    class AlterableGraphComponent : public AlterableDigraphComponent<BAS> {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Edge Edge;
 
 
-      /// The arc observer registry.
+      /// Edge alteration notifier class.
       typedef AlterationNotifier<AlterableGraphComponent, Edge>
       EdgeNotifier;
 
-      /// \brief Gives back the arc alteration notifier.
-      ///
-      /// Gives back the arc alteration notifier.
+      /// \brief Return the edge alteration notifier.
+      ///
+      /// This function gives back the edge alteration notifier.
       EdgeNotifier& notifier(Edge) const {
         return EdgeNotifier();
@@ -968,5 +977,5 @@
       struct Constraints {
         void constraints() {
-          checkConcept<AlterableGraphComponent<Base>, _Graph>();
+          checkConcept<AlterableDigraphComponent<Base>, _Graph>();
           typename _Graph::EdgeNotifier& uen
             = graph.notifier(typename _Graph::Edge());
@@ -975,35 +984,39 @@
 
         const _Graph& graph;
-
-      };
-
-    };
-
-    /// \brief Class describing the concept of graph maps
-    ///
-    /// This class describes the common interface of the graph maps
-    /// (NodeMap, ArcMap), that is maps that can be used to
-    /// associate data to graph descriptors (nodes or arcs).
-    template <typename _Graph, typename _Item, typename _Value>
-    class GraphMap : public ReadWriteMap<_Item, _Value> {
-    public:
-
-      typedef ReadWriteMap<_Item, _Value> Parent;
-
-      /// The graph type of the map.
-      typedef _Graph Graph;
+      };
+    };
+
+    /// \brief Concept class for standard graph maps.
+    ///
+    /// This class describes the concept of standard graph maps, i.e.
+    /// the \c NodeMap, \c ArcMap and \c EdgeMap subtypes of digraph and 
+    /// graph types, which can be used for associating data to graph items.
+    /// The standard graph maps must conform to the ReferenceMap concept.
+    template <typename GR, typename K, typename V>
+    class GraphMap : public ReferenceMap<K, V, V&, const V&> {
+      typedef ReferenceMap<K, V, V&, const V&> Parent;
+
+    public:
+
       /// The key type of the map.
-      typedef _Item Key;
+      typedef K Key;
       /// The value type of the map.
-      typedef _Value Value;
+      typedef V Value;
+      /// The reference type of the map.
+      typedef Value& Reference;
+      /// The const reference type of the map.
+      typedef const Value& ConstReference;
+
+      // The reference map tag.
+      typedef True ReferenceMapTag;
 
       /// \brief Construct a new map.
       ///
       /// Construct a new map for the graph.
-      explicit GraphMap(const Graph&) {}
+      explicit GraphMap(const GR&) {}
       /// \brief Construct a new map with default value.
       ///
-      /// Construct a new map for the graph and initalise the values.
-      GraphMap(const Graph&, const Value&) {}
+      /// Construct a new map for the graph and initalize the values.
+      GraphMap(const GR&, const Value&) {}
 
     private:
@@ -1013,7 +1026,7 @@
       GraphMap(const GraphMap&) : Parent() {}
 
-      /// \brief Assign operator.
-      ///
-      /// Assign operator. It does not mofify the underlying graph,
+      /// \brief Assignment operator.
+      ///
+      /// Assignment operator. It does not mofify the underlying graph,
       /// it just iterates on the current item set and set the  map
       /// with the value returned by the assigned map.
@@ -1028,22 +1041,23 @@
       struct Constraints {
         void constraints() {
-          checkConcept<ReadWriteMap<Key, Value>, _Map >();
-          // Construction with a graph parameter
-          _Map a(g);
-          // Constructor with a graph and a default value parameter
-          _Map a2(g,t);
-          // Copy constructor.
-          // _Map b(c);
-
+          checkConcept
+            <ReferenceMap<Key, Value, Value&, const Value&>, _Map>();
+          _Map m1(g);
+          _Map m2(g,t);
+          
+          // Copy constructor
+          // _Map m3(m);
+
+          // Assignment operator
           // ReadMap<Key, Value> cmap;
-          // b = cmap;
-
-          ignore_unused_variable_warning(a);
-          ignore_unused_variable_warning(a2);
-          // ignore_unused_variable_warning(b);
-        }
-
-        const _Map &c;
-        const Graph &g;
+          // m3 = cmap;
+
+          ignore_unused_variable_warning(m1);
+          ignore_unused_variable_warning(m2);
+          // ignore_unused_variable_warning(m3);
+        }
+
+        const _Map &m;
+        const GR &g;
         const typename GraphMap::Value &t;
       };
@@ -1051,14 +1065,15 @@
     };
 
-    /// \brief An empty mappable digraph class.
-    ///
-    /// This class provides beside the core digraph features
-    /// map interface for the digraph structure.
+    /// \brief Skeleton class for mappable directed graphs.
+    ///
+    /// This class describes the interface of mappable directed graphs.
+    /// It extends \ref BaseDigraphComponent with the standard digraph 
+    /// map classes, namely \c NodeMap and \c ArcMap.
     /// This concept is part of the Digraph concept.
-    template <typename _Base = BaseDigraphComponent>
-    class MappableDigraphComponent : public _Base  {
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseDigraphComponent>
+    class MappableDigraphComponent : public BAS  {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -1066,13 +1081,13 @@
       typedef MappableDigraphComponent Digraph;
 
-      /// \brief ReadWrite map of the nodes.
-      ///
-      /// ReadWrite map of the nodes.
-      ///
-      template <typename _Value>
-      class NodeMap : public GraphMap<Digraph, Node, _Value> {
+      /// \brief Standard graph map for the nodes.
+      ///
+      /// Standard graph map for the nodes.
+      /// It conforms to the ReferenceMap concept.
+      template <typename V>
+      class NodeMap : public GraphMap<MappableDigraphComponent, Node, V> {
+        typedef GraphMap<MappableDigraphComponent, Node, V> Parent;
+
       public:
-        typedef GraphMap<MappableDigraphComponent, Node, _Value> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1083,6 +1098,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
-        NodeMap(const MappableDigraphComponent& digraph, const _Value& value)
+        /// Construct a new map for the digraph and initalize the values.
+        NodeMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
 
@@ -1093,10 +1108,10 @@
         NodeMap(const NodeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         NodeMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Node, _Value>, CMap>();
+          checkConcept<ReadMap<Node, V>, CMap>();
           return *this;
         }
@@ -1104,13 +1119,13 @@
       };
 
-      /// \brief ReadWrite map of the arcs.
-      ///
-      /// ReadWrite map of the arcs.
-      ///
-      template <typename _Value>
-      class ArcMap : public GraphMap<Digraph, Arc, _Value> {
+      /// \brief Standard graph map for the arcs.
+      ///
+      /// Standard graph map for the arcs.
+      /// It conforms to the ReferenceMap concept.
+      template <typename V>
+      class ArcMap : public GraphMap<MappableDigraphComponent, Arc, V> {
+        typedef GraphMap<MappableDigraphComponent, Arc, V> Parent;
+
       public:
-        typedef GraphMap<MappableDigraphComponent, Arc, _Value> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1121,6 +1136,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the digraph and initalise the values.
-        ArcMap(const MappableDigraphComponent& digraph, const _Value& value)
+        /// Construct a new map for the digraph and initalize the values.
+        ArcMap(const MappableDigraphComponent& digraph, const V& value)
           : Parent(digraph, value) {}
 
@@ -1131,10 +1146,10 @@
         ArcMap(const ArcMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         ArcMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Arc, _Value>, CMap>();
+          checkConcept<ReadMap<Arc, V>, CMap>();
           return *this;
         }
@@ -1183,31 +1198,32 @@
         }
 
-        _Digraph& digraph;
-      };
-    };
-
-    /// \brief An empty mappable base bipartite graph class.
-    ///
-    /// This class provides beside the core graph features
-    /// map interface for the graph structure.
+        const _Digraph& digraph;
+      };
+    };
+
+    /// \brief Skeleton class for mappable undirected graphs.
+    ///
+    /// This class describes the interface of mappable undirected graphs.
+    /// It extends \ref MappableDigraphComponent with the standard graph 
+    /// map class for edges (\c EdgeMap).
     /// This concept is part of the Graph concept.
-    template <typename _Base = BaseGraphComponent>
-    class MappableGraphComponent : public MappableDigraphComponent<_Base>  {
-    public:
-
-      typedef _Base Base;
+    template <typename BAS = BaseGraphComponent>
+    class MappableGraphComponent : public MappableDigraphComponent<BAS>  {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Edge Edge;
 
       typedef MappableGraphComponent Graph;
 
-      /// \brief ReadWrite map of the edges.
-      ///
-      /// ReadWrite map of the edges.
-      ///
-      template <typename _Value>
-      class EdgeMap : public GraphMap<Graph, Edge, _Value> {
+      /// \brief Standard graph map for the edges.
+      ///
+      /// Standard graph map for the edges.
+      /// It conforms to the ReferenceMap concept.
+      template <typename V>
+      class EdgeMap : public GraphMap<MappableGraphComponent, Edge, V> {
+        typedef GraphMap<MappableGraphComponent, Edge, V> Parent;
+
       public:
-        typedef GraphMap<MappableGraphComponent, Edge, _Value> Parent;
-
         /// \brief Construct a new map.
         ///
@@ -1218,6 +1234,6 @@
         /// \brief Construct a new map with default value.
         ///
-        /// Construct a new map for the graph and initalise the values.
-        EdgeMap(const MappableGraphComponent& graph, const _Value& value)
+        /// Construct a new map for the graph and initalize the values.
+        EdgeMap(const MappableGraphComponent& graph, const V& value)
           : Parent(graph, value) {}
 
@@ -1228,10 +1244,10 @@
         EdgeMap(const EdgeMap& nm) : Parent(nm) {}
 
-        /// \brief Assign operator.
-        ///
-        /// Assign operator.
+        /// \brief Assignment operator.
+        ///
+        /// Assignment operator.
         template <typename CMap>
         EdgeMap& operator=(const CMap&) {
-          checkConcept<ReadMap<Edge, _Value>, CMap>();
+          checkConcept<ReadMap<Edge, V>, CMap>();
           return *this;
         }
@@ -1250,5 +1266,5 @@
 
         void constraints() {
-          checkConcept<MappableGraphComponent<Base>, _Graph>();
+          checkConcept<MappableDigraphComponent<Base>, _Graph>();
 
           { // int map test
@@ -1267,33 +1283,33 @@
         }
 
-        _Graph& graph;
-      };
-    };
-
-    /// \brief An empty extendable digraph class.
-    ///
-    /// This class provides beside the core digraph features digraph
-    /// extendable interface for the digraph structure.  The main
-    /// difference between the base and this interface is that the
-    /// digraph alterations should handled already on this level.
-    template <typename _Base = BaseDigraphComponent>
-    class ExtendableDigraphComponent : public _Base {
-    public:
-      typedef _Base Base;
-
-      typedef typename _Base::Node Node;
-      typedef typename _Base::Arc Arc;
-
-      /// \brief Adds a new node to the digraph.
-      ///
-      /// Adds a new node to the digraph.
-      ///
+        const _Graph& graph;
+      };
+    };
+
+    /// \brief Skeleton class for extendable directed graphs.
+    ///
+    /// This class describes the interface of extendable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for adding 
+    /// nodes and arcs to the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
+    template <typename BAS = BaseDigraphComponent>
+    class ExtendableDigraphComponent : public BAS {
+    public:
+      typedef BAS Base;
+
+      typedef typename Base::Node Node;
+      typedef typename Base::Arc Arc;
+
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
+      /// \brief Add a new arc connecting the given two nodes.
+      ///
+      /// This function adds a new arc connecting the given two nodes
+      /// of the digraph.
       Arc addArc(const Node&, const Node&) {
         return INVALID;
@@ -1315,31 +1331,30 @@
     };
 
-    /// \brief An empty extendable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core undircted graph extend interface for the graph structure.
-    /// The main difference between the base and this interface is
-    /// that the graph alterations should handled already on this
-    /// level.
-    template <typename _Base = BaseGraphComponent>
-    class ExtendableGraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
-      typedef typename _Base::Node Node;
-      typedef typename _Base::Edge Edge;
-
-      /// \brief Adds a new node to the graph.
-      ///
-      /// Adds a new node to the graph.
-      ///
+    /// \brief Skeleton class for extendable undirected graphs.
+    ///
+    /// This class describes the interface of extendable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for adding 
+    /// nodes and edges to the graph.
+    /// This concept requires \ref AlterableGraphComponent.
+    template <typename BAS = BaseGraphComponent>
+    class ExtendableGraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
+      typedef typename Base::Node Node;
+      typedef typename Base::Edge Edge;
+
+      /// \brief Add a new node to the digraph.
+      ///
+      /// This function adds a new node to the digraph.
       Node addNode() {
         return INVALID;
       }
 
-      /// \brief Adds a new arc connects the given two nodes.
-      ///
-      /// Adds a new arc connects the the given two nodes.
-      Edge addArc(const Node&, const Node&) {
+      /// \brief Add a new edge connecting the given two nodes.
+      ///
+      /// This function adds a new edge connecting the given two nodes
+      /// of the graph.
+      Edge addEdge(const Node&, const Node&) {
         return INVALID;
       }
@@ -1360,15 +1375,15 @@
     };
 
-    /// \brief An empty erasable digraph class.
-    ///
-    /// This class provides beside the core digraph features core erase
-    /// functions for the digraph structure. The main difference between
-    /// the base and this interface is that the digraph alterations
-    /// should handled already on this level.
-    template <typename _Base = BaseDigraphComponent>
-    class ErasableDigraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
+    /// \brief Skeleton class for erasable directed graphs.
+    ///
+    /// This class describes the interface of erasable directed graphs.
+    /// It extends \ref BaseDigraphComponent with functions for removing 
+    /// nodes and arcs from the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
+    template <typename BAS = BaseDigraphComponent>
+    class ErasableDigraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -1376,12 +1391,11 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// Erase a node from the digraph. This function should
-      /// erase all arcs connecting to the node.
+      /// This function erases the given node from the digraph and all arcs 
+      /// connected to the node.
       void erase(const Node&) {}
 
       /// \brief Erase an arc from the digraph.
       ///
-      /// Erase an arc from the digraph.
-      ///
+      /// This function erases the given arc from the digraph.
       void erase(const Arc&) {}
 
@@ -1390,7 +1404,7 @@
         void constraints() {
           checkConcept<Base, _Digraph>();
-          typename _Digraph::Node node;
+          const typename _Digraph::Node node(INVALID);
           digraph.erase(node);
-          typename _Digraph::Arc arc;
+          const typename _Digraph::Arc arc(INVALID);
           digraph.erase(arc);
         }
@@ -1400,15 +1414,15 @@
     };
 
-    /// \brief An empty erasable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core erase functions for the undirceted graph structure. The
-    /// main difference between the base and this interface is that
-    /// the graph alterations should handled already on this level.
-    template <typename _Base = BaseGraphComponent>
-    class ErasableGraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
+    /// \brief Skeleton class for erasable undirected graphs.
+    ///
+    /// This class describes the interface of erasable undirected graphs.
+    /// It extends \ref BaseGraphComponent with functions for removing 
+    /// nodes and edges from the graph.
+    /// This concept requires \ref AlterableGraphComponent.
+    template <typename BAS = BaseGraphComponent>
+    class ErasableGraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
       typedef typename Base::Node Node;
       typedef typename Base::Edge Edge;
@@ -1416,12 +1430,11 @@
       /// \brief Erase a node from the graph.
       ///
-      /// Erase a node from the graph. This function should erase
-      /// arcs connecting to the node.
+      /// This function erases the given node from the graph and all edges
+      /// connected to the node.
       void erase(const Node&) {}
 
-      /// \brief Erase an arc from the graph.
-      ///
-      /// Erase an arc from the graph.
-      ///
+      /// \brief Erase an edge from the digraph.
+      ///
+      /// This function erases the given edge from the digraph.
       void erase(const Edge&) {}
 
@@ -1430,7 +1443,7 @@
         void constraints() {
           checkConcept<Base, _Graph>();
-          typename _Graph::Node node;
+          const typename _Graph::Node node(INVALID);
           graph.erase(node);
-          typename _Graph::Edge edge;
+          const typename _Graph::Edge edge(INVALID);
           graph.erase(edge);
         }
@@ -1440,20 +1453,19 @@
     };
 
-    /// \brief An empty clearable base digraph class.
-    ///
-    /// This class provides beside the core digraph features core clear
-    /// functions for the digraph structure. The main difference between
-    /// the base and this interface is that the digraph alterations
-    /// should handled already on this level.
-    template <typename _Base = BaseDigraphComponent>
-    class ClearableDigraphComponent : public _Base {
-    public:
-
-      typedef _Base Base;
+    /// \brief Skeleton class for clearable directed graphs.
+    ///
+    /// This class describes the interface of clearable directed graphs.
+    /// It extends \ref BaseDigraphComponent with a function for clearing
+    /// the digraph.
+    /// This concept requires \ref AlterableDigraphComponent.
+    template <typename BAS = BaseDigraphComponent>
+    class ClearableDigraphComponent : public BAS {
+    public:
+
+      typedef BAS Base;
 
       /// \brief Erase all nodes and arcs from the digraph.
       ///
-      /// Erase all nodes and arcs from the digraph.
-      ///
+      /// This function erases all nodes and arcs from the digraph.
       void clear() {}
 
@@ -1465,27 +1477,33 @@
         }
 
-        _Digraph digraph;
-      };
-    };
-
-    /// \brief An empty clearable base undirected graph class.
-    ///
-    /// This class provides beside the core undirected graph features
-    /// core clear functions for the undirected graph structure. The
-    /// main difference between the base and this interface is that
-    /// the graph alterations should handled already on this level.
-    template <typename _Base = BaseGraphComponent>
-    class ClearableGraphComponent : public ClearableDigraphComponent<_Base> {
-    public:
-
-      typedef _Base Base;
+        _Digraph& digraph;
+      };
+    };
+
+    /// \brief Skeleton class for clearable undirected graphs.
+    ///
+    /// This class describes the interface of clearable undirected graphs.
+    /// It extends \ref BaseGraphComponent with a function for clearing
+    /// the graph.
+    /// This concept requires \ref AlterableGraphComponent.
+    template <typename BAS = BaseGraphComponent>
+    class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {
+    public:
+
+      typedef BAS Base;
+
+      /// \brief Erase all nodes and edges from the graph.
+      ///
+      /// This function erases all nodes and edges from the graph.
+      void clear() {}
 
       template <typename _Graph>
       struct Constraints {
         void constraints() {
-          checkConcept<ClearableGraphComponent<Base>, _Graph>();
-        }
-
-        _Graph graph;
+          checkConcept<Base, _Graph>();
+          graph.clear();
+        }
+
+        _Graph& graph;
       };
     };
